#--------------------- Load packages (packages need to be installed)-------------------
require(snowfall)
require(coda)
require(MASS) 
require(bayesm)
require(mvtnorm)
require(mnormt)
library(compiler)
require(zoo)
require(Matrix)
#---------------------------------------------------------------------------------------------------------------------#
#Creates Dummies
get_dum <- function(lambda,lambda1,lambda2,M,M_,p,S_prior,sigma_sq,nabla,X,Y_=Ypre,W_=Wexpre,s1=sig_wex,lambda3){
  #nabla <- 1/10000
  #Prior mean 
  pr_mean <- diag(M)*1
  pr_mean[grepl("Dp",colnames(Y_)),grepl("Dp",colnames(Y_))] <- 1
  y_ <- as.numeric(apply(Y_,2,mean))
  w_ <- as.numeric(apply(W_,2,mean))
  #create dummy matrices
  K <- ncol(X)
  d_end <- matrix(0,M*p,K)
  d_det <- matrix(0,1,K)
  d_wex <- matrix(0,(M_*p)+M_,K)
  colnames(d_end) <- colnames(d_det) <- colnames(d_wex) <- colnames(X)
  
  ydum <- rbind(matrix(0,1,M),matrix(0,(M_*p+M_),M),S_prior,(diag(as.numeric(sigma_sq))%*%pr_mean)/lambda,matrix(0,(M*p)-M,M))
  #same for sum of coefficients
  y_init <- t(as.matrix(y_))/lambda2
  #same for sum of coefficients
  y_sum <- (diag(y_)*pr_mean)/lambda3
  
  ydum <- rbind(ydum,y_init,y_sum) #,y_sum,
  #------------------------------------------------------------------------------------------------
  J <- diag(1:p)
  J1 <- diag(1:(p+1))
  #dummy part for endogenous variables
  d_end[1:(M*p),grepl("Ylag",colnames(d_wex))] <- kronecker(J,diag(as.numeric(sigma_sq))/lambda)
  d_end_sum <- kronecker(matrix(1,1,p),diag(y_)*pr_mean)/lambda3
  #dummy for the initial obs prior
  d_end_init <- kronecker(matrix(1,1,p),t(as.matrix(y_/lambda2)))
  #dummy for determinisics
  d_det[1:1,1:1] <- diag(1)*nabla
  d_det_init <- matrix(0,1,1)
  d_det_sum <- matrix(0,M,1)
  #dummy for SIGMA
  d_sig <- matrix(0,M,K)
  #dummy for weakly exogenous
  d_wex[1:((M_*p)+M_),grepl("Wex",colnames(d_wex))] <- kronecker(J1,diag(as.numeric(s1))/lambda1)
  d_wex_init <- kronecker(matrix(1,1,p+1),t(as.matrix(w_/lambda2)))
  #d_wex_sum <- kronecker(t(as.matrix(seq(1,(p+1)))),diag(w_))*1/lambda3
  d_wex_sum <- matrix(0,M,(M_*p)+M_)
  #combine for sum of coefficient prior
  d_init <- cbind(d_det_init,d_wex_init,d_end_init)
  d_sum <- cbind(d_det_sum,d_wex_sum,d_end_sum)
  
  xdum <- rbind(d_det,d_wex,d_sig,d_end,d_init,d_sum)#,),,d_init
  return(list(X=xdum,Y=ydum))
}
get_ML <- function(lambdas_,Y_,X_,K,A_prior,S_prior,sigma_sq,v_prior,T,M,M_,p,sig_wex){
  lambda <- lambdas_[[1]];lambda1 <- lambdas_[[2]];lambda2 <- lambdas_[[3]];lambda3 <- lambdas_[[4]]
  
  dum <- get_dum(lambda=lambdas_[[1]],lambda1=lambdas_[[2]],lambda2=1,M=M,M_=M_,S_prior=diag(as.numeric(sigma_sq)),p=p,sigma_sq=sigma_sq,nabla=lambda2,X=X_,s1=sig_wex,lambda3=1)  
  X_ <- rbind(X_,dum$X);Y_ <- rbind(Y_,dum$Y)
  
  #check whether V_prior exist
  cc <- try(solve(crossprod(dum$X)), silent=T) 
  if(is(cc,"try-error")) {  
    ml <- -Inf
  }else{
    
    V_prior <- solve(crossprod(dum$X))
    V_post <- solve(crossprod(X_))
    A_post <- V_post%*%t(X_)%*%Y_
    
    S_post <- crossprod(Y_-X_%*%A_post)  
    
    ml <- (-M/2 * (log(det(V_prior))+log(det(crossprod(X_))))+(-(T+M+v_prior-1)/2)*log(det(S_post)))
  }
  return(ml)
}
#---------------------------------------------------------------------------------------------------------------------#
#Creates Dummies #2
get_dum_minn <- function(lambda,lambda1,lambda2,M,M_,p,S_prior,sigma_sq,nabla,X,Y_=Ypre,W_=Wexpre,s1=sig_wex,lambda3){
  #Initial conditions
  #nabla <- 1/1000
  #Prior mean 
  pr_mean <- diag(M)*1
  pr_mean[grepl("Dp",colnames(Y_)),grepl("Dp",colnames(Y_))] <- 1#0.2
  y_ <- as.numeric(apply(Y_,2,mean))
  w_ <- as.numeric(apply(W_,2,mean))
  #create dummy matrices
  K <- ncol(X)
  d_end <- matrix(0,M*p,K)
  d_det <- matrix(0,1,K)
  d_wex <- matrix(0,(M_*p)+M_,K)
  colnames(d_end) <- colnames(d_det) <- colnames(d_wex) <- colnames(X)
  
  ydum <- rbind(matrix(0,1,M),matrix(0,(M_*p+M_),M),S_prior,(diag(as.numeric(sigma_sq))%*%pr_mean)/lambda,matrix(0,(M*p)-M,M))
  #same for sum of coefficients
  y_init <- t(as.matrix(y_))/lambda2
  #same for sum of coefficients
  y_sum <- diag(y_)/lambda3
  
  ydum <- rbind(ydum) #,y_sum,
  #------------------------------------------------------------------------------------------------
  J <- diag(1:p)
  J1 <- diag(1:(p+1))
  #dummy part for endogenous variables
  d_end[1:(M*p),grepl("Ylag",colnames(d_wex))] <- kronecker(J,diag(as.numeric(sigma_sq))/lambda)
  d_end_sum <- kronecker(t(as.matrix(seq(1,p))),diag(y_))*1/lambda2
  #dummy for the initial obs prior
  d_end_init <- kronecker(matrix(1,1,p),t(as.matrix(y_/lambda2)))
  #dummy for determinisics
  d_det[1,1] <- diag(1)*nabla
  d_det_init <- matrix(0,1,1)
  d_det_sum <- matrix(0,M,1)
  #dummy for SIGMA
  d_sig <- matrix(0,M,K)
  #dummy for weakly exogenous
  d_wex[1:((M_*p)+M_),grepl("Wex",colnames(d_wex))] <- kronecker(J1,diag(as.numeric(s1))/lambda1)
  d_wex_init <- kronecker(matrix(1,1,p+1),t(as.matrix(w_/lambda2)))
  #d_wex_sum <- kronecker(t(as.matrix(seq(1,(p+1)))),diag(w_))*1/lambda3
  d_wex_sum <- matrix(0,M,(M_*p)+M_)
  #combine for sum of coefficient prior
  d_init <- cbind(d_det_init,d_wex_init,d_end_init)
  d_sum <- cbind(d_det_sum,d_wex_sum,d_end_sum)
  
  xdum <- rbind(d_det,d_wex,d_sig,d_end)#,),,d_init
  
  return(list(X=xdum,Y=ydum))
}
#Creates Dummies #3
get_dum_ar <- function(alphas,lambda,lambda1,lambda2,M,M_,p,S_prior,sigma_sq,nabla,X,Y_=Ypre,W_=Wexpre,s1=sig_wex,lambda3){
  #Initial conditions
  nabla <- 1/100000
  #Prior mean 
  pr_mean <- diag(M)*diag(as.numeric(alphas))
  y_ <- as.numeric(apply(Y_,2,mean))
  w_ <- as.numeric(apply(W_,2,mean))
  #create dummy matrices
  K <- ncol(X)
  d_end <- matrix(0,M*p,K)
  d_det <- matrix(0,2,K)
  d_wex <- matrix(0,(M_*p)+M_,K)
  colnames(d_end) <- colnames(d_det) <- colnames(d_wex) <- colnames(X)
  
  ydum <- rbind(matrix(0,2,M),matrix(0,(M_*p+M_),M),S_prior,(diag(as.numeric(sigma_sq))%*%pr_mean)/lambda,matrix(0,(M*p)-M,M))
  #same for sum of coefficients
  y_init <- t(as.matrix(y_))/lambda2
  #same for sum of coefficients
  y_sum <- diag(y_)/lambda3
  
  ydum <- rbind(ydum) #,y_sum,
  #------------------------------------------------------------------------------------------------
  J <- diag(1:p)
  J1 <- diag(1:(p+1))
  #dummy part for endogenous variables
  d_end[1:(M*p),grepl("Ylag",colnames(d_wex))] <- kronecker(J,diag(as.numeric(sigma_sq))/lambda)
  d_end_sum <- kronecker(t(as.matrix(seq(1,p))),diag(y_))*1/lambda2
  #dummy for the initial obs prior
  d_end_init <- kronecker(matrix(1,1,p),t(as.matrix(y_/lambda2)))
  #dummy for determinisics
  d_det[1:2,1:2] <- diag(2)*nabla
  d_det_init <- matrix(0,1,2)
  d_det_sum <- matrix(0,M,2)
  #dummy for SIGMA
  d_sig <- matrix(0,M,K)
  #dummy for weakly exogenous
  d_wex[1:((M_*p)+M_),grepl("Wex",colnames(d_wex))] <- kronecker(J1,diag(as.numeric(s1))/lambda1)
  d_wex_init <- kronecker(matrix(1,1,p+1),t(as.matrix(w_/lambda2)))
  #d_wex_sum <- kronecker(t(as.matrix(seq(1,(p+1)))),diag(w_))*1/lambda3
  d_wex_sum <- matrix(0,M,(M_*p)+M_)
  #combine for sum of coefficient prior
  d_init <- cbind(d_det_init,d_wex_init,d_end_init)
  d_sum <- cbind(d_det_sum,d_wex_sum,d_end_sum)
  
  xdum <- rbind(d_det,d_wex,d_sig,d_end)#,),,d_init
  
  return(list(X=xdum,Y=ydum))
}
#Get marginal likelihood
#---------------------------------------------------------------------------------------------------------------------#
get_ML_minn <- function(lambdas_,Y_,X_,K,A_prior,S_prior,sigma_sq,v_prior,T,M,M_,p,sig_wex){
  lambda <- lambdas_[[1]];lambda1 <- lambdas_[[2]];lambda2 <- lambdas_[[3]];lambda3 <- lambdas_[[4]]
  
  dum <- get_dum_minn(lambda=lambdas_[[1]],lambda1=lambdas_[[2]],lambda2=1,M=M,M_=M_,S_prior=diag(as.numeric(sigma_sq)),p=p,sigma_sq=sigma_sq,nabla=1,X=X_,s1=sig_wex,lambda3=1)  
  X_ <- rbind(X_,dum$X);Y_ <- rbind(Y_,dum$Y)
  
  #check whether V_prior exist
  cc <- try(solve(crossprod(dum$X)), silent=T) 
  if(is(cc,"try-error")) {  
    ml <- Inf
  }else{
    
    V_prior <- solve(crossprod(dum$X))
    V_post <- solve(crossprod(X_))
    A_post <- V_post%*%t(X_)%*%Y_
    
    S_post <- crossprod(Y_-X_%*%A_post)  
    
    ml <- 1*(-M/2 * (log(det(V_prior))+log(det(crossprod(X_))))+(-(T+M+v_prior-1)/2)*log(det(S_post)))
  }
  return(ml)
}
#Estimate BVARX models
#---------------------------------------------------------------------------------------------------------------------#
BVAR <- function(hyper,nr,prior,fperiods,gW=gW,bigx=xglobal,Daten,cN,wexoff=0){
  #-------------------------------- This function estimates a BVARX model for several different prior distributions---------------------------------------------#
  #-------------------------------- Parts of this code are based on the codes supplied by Gary Koop and Dimitris Korobilis--------------------------------------#
  #-------------------------------- hyper = 4x1 vector of hyperparameters , nr = selects a given country -------------------------------------------------------#
  #-------------------------------- if prior==1 -> flat prior VARX (ML results) --------------------------------------------------------------------------------#
  #-------------------------------- if prior==2 -> Minnesota based on a fixed SIGMA (SIGMA from ML) ------------------------------------------------------------#
  #-------------------------------- if prior==3 -> Conjugate Minnesota prior VARX based on dummy observations --------------------------------------------------#
  #-------------------------------- if prior==4 -> Conjugate S&Z prior setup -----------------------------------------------------------------------------------#
  #-------------------------------- if prior==5 -> SSVS VAR as in George et al (2008) --------------------------------------------------------------------------#
  #-------------------------------- if prior==7 -> AR(p) model with estimated VC matrix ------------------------------------------------------------------------#
  #-------------------------------- fperiods = length of the hold-out (in our case 40 quarters), gW = list with the weightings, bigx = global vector -----------#
  #-------------------------------- Daten = list object with the data (supplied, do not change), cN = character vector with ISO 2 country codes ----------------#
  #-------------------------------- wexoff = shuts off weakly exogenous variabels by setting the prior variances equal to 1/1000000 ----------------------------#
  #----------------------Load packages ------------------
  require(snowfall)
  require(coda)
  require(MASS) 
  require(bayesm)
  require(mvtnorm)
  require(mnormt)
  library(compiler)
  require(zoo)
  require(Matrix)
  #----------------------user input stuff----------------
  xglobal <- bigx
  gW <- gW
  nr <- nr
  p <- 5#number of lags of the dependent variable
  pwex <- 5 #number of lags of weakly exogenous variables (will be included later)
  cons <- 1 #1 includes constant, 0 exclude
  prior <- prior #1 1 diffuse, 2 litterman, 3 nat conjugate
  trend <- 0 #1 includes trend component i.e. alpha*t
  h  <- fperiods               # Number of forecast periods
  #Starting values for the hyperparameters used later on
  #--------------------------------------------------------
  a_bar_1 <- hyper[1]
  a_bar_2 <- hyper[2]
  a_bar_3 <- hyper[3]
  a_bar_4 <- hyper[4]
  #--------------Gibbs-related prelims---------------------
  nsave <- 15000 # final number of draws to save
  nburn <- 15000 #Burn-INs
  ntot <- nsave+nburn # total draws
  #--------------------Reading in the Data-----------------
  Names <- cN
  #Dummies <- Data[[2]]
  End <- xglobal[,substr(colnames(xglobal),1,2)==Names[[nr]]]
  class(End) <- "numeric"
  PIP <- NULL
  
  #xglobal <- globalV(Daten,diff=diff)
  class(xglobal) <- "numeric"
  W <- gW[[nr]]
  
  #Construct wWeakly exogenous variables
  all <- W%*%t(xglobal)
  Wex <- all[(ncol(End)+1):nrow(all),]
  Wex <- t(Wex)
  
  
  #splitting the dataset -> PRE-Sample Data 
  class(Wex) <- "numeric"  
  
  X <- End
  Yraw <- X
  
  Yraw <- as.matrix(Yraw)
  class(Yraw) <- "numeric"
  #--------------------Data Preparation-------------------------
  dimYraw <- dim(Yraw) #get dimensions of the dependent variable
  Traw <- dimYraw[1]
  N <- dimYraw[2]
  
  #--------------------Model Specification----------------------
  Y1 <- Yraw
  Y2 <- Yraw
  Exogenous <- matrix(0,0,0)
  Dummies <- matrix(0,0,0)
  max_ <- NULL
  #-------------------------------------------------------------
  #uses the function above
  Ylag <- mlag(Y2,p)
  Wexlag <- mlag(Wex,pwex)
  
  M_ <- ncol(Wex)
  
  colnames(Wex) <- rep("Wex",ncol(Wex))
  
  #creates nametags for the lags, makes it easier to select the corresponding coefficient matrices later on
  nameslags <- NULL
  wexnameslags <- NULL
  for (ii in 1:p){
    nameslags <- c(nameslags,rep(paste("Ylag",ii,sep=""),ncol(Y2)))
    wexnameslags <- c(wexnameslags,rep(paste("Wexlag",ii,sep=""),ncol(Wex)))
  }
  colnames(Ylag) <- nameslags
  colnames(Wexlag) <- wexnameslags
  X1 <- cbind(Wex,Wexlag,Ylag)
  #X1 <- cbind(1:nrow(X1),X1)
  
  Wexpre <<- Wex[1:p,]
  Ypre <<- Y1[1:p,]
  
  Exlag <- matrix(0,0,0)
  
  
  X1 <- X1[(p+1):Traw,]
  #---------we need to include this for the trend component and constant------------#
  #colnames(X1)[[1]] <- "trend"
  X1 <- cbind(1,X1)
  colnames(X1)[[1]] <- "constant" 
  
  #-----------------get size of the final matrix X---------------------#
  dimX <- dim(X1)
  Traw3 <- dimX[1]
  K <- dimX[2]
  T <- Traw-p
  
  #------------------create block diagonal matrix z-------------------#
  Z1 <- kronecker(diag(N),X1)
  Y1 <- Yraw[(p+1):Traw,]
  
  #----------------Forecasting SET-UP---------------------------------#
  #keeps the last "h" or 1 observations to evaluate forecasts
  Yfull <- Y1 #saves the full data
  Xfull <- X1 
  
  Y <- Y1[1:(nrow(Y1)-h),]
  X <- X1[1:(nrow(X1)-h),]
  Z <- kronecker(diag(N),X)
  T <- T-h 
  #----------------------PRIOR FUN------------------------------
  #----------------------getting OLS estimates------------------ 
  A_OLS  <-  ginv(t(X)%*%X)%*%(t(X)%*%Y)
  a_OLS <- as.vector(A_OLS) #vectorizes A_OLS, i.e. a_OLS=vec(A_OLS)
  SSE  <-  t((Y - X%*%A_OLS))%*%(Y - X%*%A_OLS)
  SIGMA_OLS  <-  SSE/(T-K+1)
  
  #-------------Initialize Bayesian Posteriors using OLS values-
  alpha <- a_OLS # single draw from the posterior of alpha
  ALPHA <- A_OLS # -,,- ALPHA
  SSE_Gibbs <- SSE # of SSE
  SIGMA <- SIGMA_OLS #of SIGMA
  
  #store the draws:
  alpha_draws <- matrix(0,nsave,K*N)
  ALPHA_draws <- array(0,dim=c(nsave,K,N))
  SIGMA_draws <- array(0,dim=c(nsave,N,N))
  lambda_draws <- matrix(0,nsave,3)
  PL <- matrix(0,nsave,1)
  
  #-------------------PRIOR Hyperparameters--------------------
  M <- N
  n <- K*N
  if (prior==1){
    lambdas <- seq(1,4)
  } else if (prior==2){ #Minnesota Prior
    lambdas <- seq(1,4)
    ind <- matrix(0,N,p)
    for (i in 1:N){
      ind[i,] <- seq(cons+trend+ncol(Dummies)+ncol(Exogenous)+ncol(Exlag)+ncol(Wex)+ncol(Wexlag)+i,K, by=N)
    }
    A_prior <- matrix(0,K,N)
    for (j in 1:N){
      if (j==2){
         A_prior[ind[j,1],j] <- 1
      }else{
        A_prior[ind[j,1],j] <- 1 #prior view that the variables follow a random walk
      }
    }
    
    
    a_prior <- matrix(as.vector(A_prior))
    #Hyperparameters variance of alpha 
    
    #Now get residual variances of univariate p-lag AR models. 
    #AR(p) is run on each equation, ignoring the constant and exogenous variables
    #-------------------------------------------------------------------------
    sigma_sq  <- matrix(0,N,1) #vector which stores the residual variance
    
    for (i in 1:N){
      Ylag_i <- mlag(Yraw[,i],p)
      Ylag_i <- Ylag_i[(p+1):nrow(Ylag_i),]
      Y_i <- Yraw[(p+1):nrow(Yraw),i]
      alpha_i <- solve(t(Ylag_i)%*%Ylag_i)%*%t(Ylag_i)%*%Y_i
      sigma_sq[i,1] <- (1/(nrow(Yraw)-p))*t(Y_i-Ylag_i%*%alpha_i)%*%(Y_i-Ylag_i%*%alpha_i) 
    }
    #------------------------------------------------------------------------
    sig_wex <<- matrix(0,M_,1)
    for (j in 1:M_){
      Ywex_i <- mlag(Wex[,j],p)
      Ywex_i <- Ywex_i[(p+1):nrow(Ywex_i),]
      Yw_i <- Wex[(p+1):nrow(Wex),j]
      alpha_w <- solve(crossprod(Ywex_i))%*%t(Ywex_i)%*%Yw_i
      sig_wex[j,1] <- (1/(nrow(Wex)-p))*t(Yw_i-Ywex_i%*%alpha_w)%*%(Yw_i-Ywex_i%*%alpha_w)
    }
    
    #-----------------PRIOR HYPERPARAMETERS-------------------
    #creating an array of dimension K x N, which will contain the K diagonal elements of the covmatrix, in each eqn
    V_i <- matrix(0,K,N)
    
    rownames(V_i) <- colnames(X)
    
    #this double loop fills the prior covariance matrix
    for (i in 1:N){ #for each i equation
      for (j in 1:K){ #for each variable on the rhs
        if (cons==1) {
          if (j<= (cons+ncol(Dummies)+ncol(Exogenous)+ncol(Exlag)+ncol(Wex)+ncol(Wexlag))) {
            V_i[j,i] <- a_bar_3*sigma_sq[i,1] #variance on constant,trend, dummies and on ex variables         
          }    
          else if (any(j==ind[i,])) {
            V_i[j,i] <- a_bar_1/(p^2) #variance on own lags
          } 
          else
          {
            for (kj in 1:N){
              if (any(j==ind[kj,]))
              {
                ll <- kj
              }  
            } 
            V_i[j,i] <- (a_bar_2*sigma_sq[i,1])/((p^2)*sigma_sq[ll,1])
          }
        }       
        
        else{
          if (j<= (trend+ncol(Dummies)+ncol(Exogenous)+ncol(Exlag)+ncol(Wex)+ncol(Wexlag))) {
            V_i[j,i] <- a_bar_3*sigma_sq[i,1] #variance on constant and on ex variables (need to be included)         
          }    
          else if (any(j==ind[i,])) {
            V_i[j,i] <- a_bar_1/(p^2) #variance on own lags
          } 
          else
          {
            for (kj in 1:N){
              if (any(j==ind[kj,]))
              {
                ll <- kj
              }  
            } 
            V_i[j,i] <- (a_bar_2*sigma_sq[i,1])/((p^2)*sigma_sq[ll,1])
          }
        }
      }
    }  
    
    #prior variance on const & trend
    for (jj in 1:N){
      V_i[1:2,jj] <- a_bar_3*sigma_sq[jj,1]
    }
    #starts the Wex part
    for (jj in 1:N){
      for (kk in 0:p){
        if (kk==0) slct <- which(colnames(X)=="Wex") else slct <- which(colnames(X)==paste("Wexlag",kk,sep=""))
        temp <- V_i[slct,jj]
        for (ii in 1:length(slct)){
          temp[ii] <- a_bar_4*sigma_sq[jj,1]/(sig_wex[ii,1]*(kk+1))
        }
        V_i[slct,jj] <- temp
      }
    }
    
    #diagonalising V_i to yield V_prior
    diagV_i <- as.vector(V_i)
    V_prior <- diag(diagV_i)
    v_prior  <-  N
    #sigma equals the OLS quantity
    SIGMA <- SIGMA_OLS
    S_prior <- diag(N)*1/100
    #sigma equals the OLS quantity
    SIGMA <- SIGMA_OLS
  }else if (prior==3){
    #-------------------PRIOR Hyperparameters--------------------
    n <- K*N
    v_prior <- M
    #Hyperparameters on a distributed as N(a_prior, SIGMA x V_prior)
    ind <- matrix(0,N,p)
    for (i in 1:N){
      ind[i,] <- seq(cons+trend+ncol(Dummies)+ncol(Exogenous)+ncol(Exlag)+ncol(Wex)+ncol(Wexlag)+i,K, by=N)
    }
    
    A_prior <<- matrix(0,K,N)
    for (j in 1:N){
      if (j==2){
        A_prior[ind[j,1],j] <- 1
      }else{
        A_prior[ind[j,1],j] <- 1 #prior view that the variables follow a random walk
      }
    }
    S_prior <<- diag(N)*10 #0.1
    
    #Now get residual variances of univariate p-lag AR models. 
    #AR(p) is run on each equation, ignoring the constant and exogenous variables
    #-------------------------------------------------------------------------
    sigma_sq  <- matrix(0,N,1) #vector which stores the residual variance
    for (i in 1:N){
      Ylag_i <- mlag(Yraw[,i],p)
      Ylag_i <- Ylag_i[(p+1):nrow(Ylag_i),]
      Y_i <- Yraw[(p+1):nrow(Yraw),i]
      alpha_i <- solve(t(Ylag_i)%*%Ylag_i)%*%t(Ylag_i)%*%Y_i
      sigma_sq[i,1] <- (1/(nrow(Yraw)-p))*t(Y_i-Ylag_i%*%alpha_i)%*%(Y_i-Ylag_i%*%alpha_i) 
    }
    #------------------------------------------------------------------------
    sig_wex <<- matrix(0,M_,1)
    for (j in 1:M_){
      Ywex_i <- mlag(Wex[,j],p)
      Ywex_i <- Ywex_i[(p+1):nrow(Ywex_i),]
      Yw_i <- Wex[(p+1):nrow(Wex),j]
      alpha_w <- solve(crossprod(Ywex_i))%*%t(Ywex_i)%*%Yw_i
      sig_wex[j,1] <- (1/(nrow(Wex)-p))*t(Yw_i-Ywex_i%*%alpha_w)%*%(Yw_i-Ywex_i%*%alpha_w)
    }
    #Maximizes the ML with respect to the hyperparameters controlling the tightness on the weakly exogenous and endogenous variables
     grid <- c(1/10000,1/1000,0.01, 0.025, 0.050, 0.10, 0.15, 0.20, 0.25, 0.30, 0.35, 0.40, 0.45, 0.50, 0.75, 1, 2,1000)
     ML_ <- matrix(0,length(grid)^2,3)
     i_ <- 0
     for (ii in 1:length(grid)){
       for (jj in 1:length(grid)){
         i_ <- i_+1
         ML_[i_,] <- c(get_ML(c(grid[[ii]],grid[[jj]],1,1),Y,X,K,A_prior,S_prior,sigma_sq,v_prior,T,M,M_,p,sig_wex=sig_wex),grid[[ii]],grid[[jj]])
      }
     }

    lambdas<- c(ML_[which(ML_[,1]==max(ML_[,1]))[[1]],2:3],1,1)
    if (wexoff==1) lambdas[[2]] <- 1/1000000
    #Create dummy observations (see paper)
    dums <- get_dum(lambda=lambdas[[1]],lambda1=lambdas[[2]],lambda2=lambdas[[3]],M=M,M_=M_,S_prior=diag(as.numeric(sigma_sq)),p=p,sigma_sq=sigma_sq,nabla=1,X=X,s1=sig_wex,lambda3=lambdas[[4]])
    ydum <- dums$Y;xdum <- dums$X 
    ML <- get_ML(lambdas,Y,X,K,A_prior,S_prior,sigma_sq,v_prior,T,M,M_,p,sig_wex=sig_wex)
  }else if (prior==4){
    #-------------------PRIOR Hyperparameters--------------------
    n <- K*N
    v_prior <- M
    #Hyperparameters on a distributed as N(a_prior, SIGMA x V_prior)
    ind <- matrix(0,N,p)
    for (i in 1:N){
      ind[i,] <- seq(cons+trend+ncol(Dummies)+ncol(Exogenous)+ncol(Exlag)+ncol(Wex)+ncol(Wexlag)+i,K, by=N)
    }
    
    A_prior <<- matrix(0,K,N)
    for (j in 1:N){
      if (j==2){
        A_prior[ind[j,1],j] <- 1
      }else{
        A_prior[ind[j,1],j] <- 1 #prior view that the variables follow a random walk
      }
    }
    S_prior <<- diag(N)*10 #0.1
    
    #Now get residual variances of univariate p-lag AR models. 
    #AR(p) is run on each equation, ignoring the constant and exogenous variables
    #-------------------------------------------------------------------------
    sigma_sq  <- matrix(0,N,1) #vector which stores the residual variance
    for (i in 1:N){
      Ylag_i <- mlag(Yraw[,i],p)
      Ylag_i <- Ylag_i[(p+1):nrow(Ylag_i),]
      Y_i <- Yraw[(p+1):nrow(Yraw),i]
      alpha_i <- solve(t(Ylag_i)%*%Ylag_i)%*%t(Ylag_i)%*%Y_i
      sigma_sq[i,1] <- (1/(nrow(Yraw)-p))*t(Y_i-Ylag_i%*%alpha_i)%*%(Y_i-Ylag_i%*%alpha_i) 
    }
    #------------------------------------------------------------------------
    sig_wex <<- matrix(0,M_,1)
    for (j in 1:M_){
      Ywex_i <- mlag(Wex[,j],p)
      Ywex_i <- Ywex_i[(p+1):nrow(Ywex_i),]
      Yw_i <- Wex[(p+1):nrow(Wex),j]
      alpha_w <- solve(crossprod(Ywex_i))%*%t(Ywex_i)%*%Yw_i
      sig_wex[j,1] <- (1/(nrow(Wex)-p))*t(Yw_i-Ywex_i%*%alpha_w)%*%(Yw_i-Ywex_i%*%alpha_w)
    }
    

    grid <- c(1/10000,1/1000,0.01, 0.025, 0.050, 0.10, 0.15, 0.20, 0.25, 0.30, 0.35, 0.40, 0.45, 0.50, 0.75, 1, 2,1000)
    ML_ <- matrix(0,length(grid)^2,3)
    i_ <- 0
    for (ii in 1:length(grid)){
      for (jj in 1:length(grid)){
        i_ <- i_+1
        ML_[i_,] <- c(get_ML_minn(c(grid[[ii]],grid[[jj]],1,1),Y,X,K,A_prior,S_prior,sigma_sq,v_prior,T,M,M_,p,sig_wex=sig_wex),grid[[ii]],grid[[jj]])
      }
    }
    
    ML_ <- ML_[!is.infinite(ML_[,1]),]
    
    lambdas<- c(ML_[which(ML_[,1]==max(ML_[,1]))[[1]],2:3],1,1)
    if (wexoff==1) lambdas[[2]] <- 1/1000000

    dums <- get_dum_minn(lambda=lambdas[[1]],lambda1=lambdas[[2]],lambda2=lambdas[[3]],M=M,M_=M_,S_prior=diag(as.numeric(sigma_sq)),p=p,sigma_sq=sigma_sq,nabla=1,X=X,s1=sig_wex,lambda3=lambdas[[4]])
    ydum <- dums$Y;xdum <- dums$X 
    ML <- get_ML(lambdas,Y,X,K,A_prior,S_prior,sigma_sq,v_prior,T,M,M_,p,sig_wex=sig_wex)
  }else if (prior==5){
      #This part is based on Koop/Korobilis; The paper uses an uninformative prior on SIGMA whereas this code would also support shrinkage on the covariances
    gamma_draws <- matrix(0,nsave,n)
    M <- N
    #---------------------PRIOR SETUP FOR SSVS PRIOR----------------#
    # Priors on SIGMA
    # SSVS variances for non-diagonal elements of SIGMA     / No shrinkage prior on the coefficients if kappa_0 = kappa_1
    kappa_0  <-  10 #Set kappa_[0ij], kappa_[1ij]
    kappa_1  <-  10
    
    # Hyperparameters for diagonal elements of SIGMA (Gamma density)
    a_i  <-  0.01
    b_i  <-  0.01
    
    # Hyperparameters for Gamma ~ BERNOULLI(m,p_i), see eq. (14)
    p_i  <-  .5
    
    # Hyperparameters for Omega_[j] ~ BERNOULLI(j,q_ij), see eq. (17)
    q_ij  <-  .5
    
    # Initialize Gamma and Omega vectors
    gammas  <-  matrix(1,n,1)       # vector of Gamma
    omega <- list() #!!!!!!!
    for (kk_1 in 1:(M-1)){
      omega[[kk_1]]  <-  matrix(1,kk_1,1)  # Omega_j
    }
    lambdas <- seq(1,4)
    
  }else if (prior==7){
    #-------------------PRIOR Hyperparameters--------------------
    n <- K*N
    v_prior <- M
    #Hyperparameters on a distributed as N(a_prior, SIGMA x V_prior)
    ind <- matrix(0,N,p)
    for (i in 1:N){
      ind[i,] <- seq(cons+trend+ncol(Dummies)+ncol(Exogenous)+ncol(Exlag)+ncol(Wex)+ncol(Wexlag)+i,K, by=N)
    }
    
    A_prior <<- matrix(0,K,N)
    for (j in 1:N){
      if (j==2){
        A_prior[ind[j,1],j] <- 1
      }else{
        A_prior[ind[j,1],j] <- 1 #prior view that the variables follow a random walk
      }
    }
    S_prior <<- diag(N)*10 #0.1
    
    #Now get residual variances of univariate p-lag AR models. 
    #AR(p) is run on each equation, ignoring the constant and exogenous variables
    #-------------------------------------------------------------------------
    ptrue <- p
    sigma_sq  <- matrix(0,N,1) #vector which stores the residual variance
    alph_ar <- matrix(0,N,1)
    p <- 1
    for (i in 1:N){
      Ylag_i <- mlag(Yraw[,i],p)
      Ylag_i <- Ylag_i[(p+1):nrow(Ylag_i),]
      Y_i <- Yraw[(p+1):nrow(Yraw),i]
      alpha_i <- solve(t(Ylag_i)%*%Ylag_i)%*%t(Ylag_i)%*%Y_i
      alph_ar[i,] <- alpha_i
      sigma_sq[i,1] <- (1/(nrow(Yraw)-p))*t(Y_i-Ylag_i%*%alpha_i)%*%(Y_i-Ylag_i%*%alpha_i) 
    }
    #------------------------------------------------------------------------
    sig_wex <<- matrix(0,M_,1)
    for (j in 1:M_){
      Ywex_i <- mlag(Wex[,j],p)
      Ywex_i <- Ywex_i[(p+1):nrow(Ywex_i),]
      Yw_i <- Wex[(p+1):nrow(Wex),j]
      alpha_w <- solve(crossprod(Ywex_i))%*%t(Ywex_i)%*%Yw_i
      sig_wex[j,1] <- (1/(nrow(Wex)-p))*t(Yw_i-Ywex_i%*%alpha_w)%*%(Yw_i-Ywex_i%*%alpha_w)
    }
    p <- ptrue
    #optim_ <- nlminb(c(0.1,0.1,0.1,10),get_ML_minn,M=M,X_=X,p=p,M_=M_,sigma_sq=sigma_sq,sig_wex=sig_wex,Y_=Y,T=T,v_prior=v_prior,lower=0.0001,upper=2)
    
    lambdas <- c(1/1000000,1/1000000,1/1000000,1/1000000)
    dums <- get_dum_ar(alph_ar,lambda=lambdas[[1]],lambda1=lambdas[[2]],lambda2=lambdas[[3]],M=M,M_=M_,S_prior=diag(as.numeric(sigma_sq)),p=p,sigma_sq=sigma_sq,nabla=1/10000,X=X,s1=sig_wex,lambda3=lambdas[[4]])
    ydum <- dums$Y;xdum <- dums$X 
    ML <- get_ML(lambdas,Y,X,K,A_prior,S_prior,sigma_sq,v_prior,T,M,M_,p,sig_wex=sig_wex)
  }
  #-------------------POSTERIORS-----------------------------------------
  if (prior==1){
    #Posterior hyperparameters of Alpha and Sigma with diffuse prior
    #posterior of alpha|Data multi T 
    V_post <- solve(t(X)%*%X)
    a_post <- as.vector(a_OLS)
    A_post <- A_OLS
    
    #posterior of SIGMA|Data inv W
    S_post <- SSE
    v_post <- T-K
    
    #mean and variance of multi T marg post of alpha
    alpha_mean <- a_post 
    alpha_var <- (1/(v_post-N-1))*kronecker(S_post,V_post)
    Res <- Y-X%*%A_post
    
    rownames(A_post) <- colnames(X)
    colnames(A_post) <- colnames(A_OLS)
    
    dimnames(ALPHA_draws)=list(NULL,colnames(X),colnames(A_OLS))
    
    #A_post <- apply(ALPHA_draws, c(2,3), mean)
    #S_post <- apply(SIGMA_draws,c(2,3),mean)
    Res <- Y-X%*%A_post
    
    dims <- dimnames(ALPHA_draws)[[2]] 
    #splitting the output of the gibbs sampler for predictive density later on
    a0post <- ALPHA_draws[,which(dims=="constant"),]
    a1post <- ALPHA_draws[,which(dims=="trend"),] #coefficients on the trend
    a2post <- NULL
    alpha_var <- NULL
    dummiespost <- ALPHA_draws[,which(dims=="Dummies"),] #coefficients for the dummies
    postExpost <- ALPHA_draws[,which(dims=="Exogenous"),] #coefficients for the cont.exogenous
    postExlpost <- ALPHA_draws[,which(dims=="ExogenousLag"),] #coefficients for the lagged. ex
    Lambda0post <- ALPHA_draws[,which(dims=="Wex"),]#coefficients on WEX
    SIGMApost <- SIGMA_draws
    
    Lambdapost <- NULL
    Thetapost <- NULL
    
    for (jj in 1:p) {
      Lambdapost[[jj]] <- ALPHA_draws[,which(dims==paste("Wexlag",jj,sep="")),]
      Thetapost[[jj]]<- ALPHA_draws[,which(dims==paste("Ylag",jj,sep="")),]
    }
  } else if (prior==2){
    #Minnesota prior
    V_priorinv <- diag(1/diag(V_prior))
    if (wexoff==1) SIGMA <- diag(diag(SIGMA))
    VARIANCE <- kronecker(solve(SIGMA),diag(T))
    V_post <- solve(V_priorinv+t(Z)%*%VARIANCE%*%Z)
    a_post <- V_post%*%(V_priorinv%*%a_prior+t(Z)%*%VARIANCE%*%as.vector(Y))    
    
    dimnames(ALPHA_draws)=list(NULL,colnames(X),colnames(A_OLS))
    
    #this part computes the ML using BIC approximation
    A_post <- matrix(a_post,K,N)#apply(ALPHA_draws, c(2,3), mean)
    colnames(A_post) <- colnames(A_OLS)
    rownames(A_post) <- colnames(X)
    S_post <- apply(SIGMA_draws,c(2,3),mean)
    Res <- Y-X%*%A_post
    
    dims <- dimnames(ALPHA_draws)[[2]] 
    #splitting the output of the gibbs sampler for predictive density later on
    a0post <- ALPHA_draws[,which(dims=="constant"),]
    a1post <- ALPHA_draws[,which(dims=="trend"),] #coefficients on the trend
    a2post <- NULL
    alpha_var <- NULL
    dummiespost <- ALPHA_draws[,which(dims=="Dummies"),] #coefficients for the dummies
    postExpost <- ALPHA_draws[,which(dims=="Exogenous"),] #coefficients for the cont.exogenous
    postExlpost <- ALPHA_draws[,which(dims=="ExogenousLag"),] #coefficients for the lagged. ex
    Lambda0post <- ALPHA_draws[,which(dims=="Wex"),]#coefficients on WEX
    SIGMApost <- SIGMA_draws
    
    Lambdapost <- NULL
    Thetapost <- NULL
    max_ <- NULL
    
    for (jj in 1:p) {
      Lambdapost[[jj]] <- ALPHA_draws[,which(dims==paste("Wexlag",jj,sep="")),]
      Thetapost[[jj]]<- ALPHA_draws[,which(dims==paste("Ylag",jj,sep="")),]
    }
    
  }else if (prior==3){
    #augment actual data with dummys
    Y_ <- rbind(Y,ydum)
    X_ <- rbind(X,xdum)
    #Compute posterior moments
    V_post <- solve(crossprod(X_))
    A_post <- V_post%*%t(X_)%*%Y_
    S_post <- crossprod(Y-X%*%A_post)
    v_post <- T+v_prior
    
    SIGMA <- S_post/(T-K)
    
    dimnames(ALPHA_draws)=list(NULL,colnames(X),colnames(A_OLS))    
    #A_post <- apply(ALPHA_draws, c(2,3), mean)
    #S_post <- apply(SIGMA_draws,c(2,3),mean)
    Res <- Y-X%*%A_post
    
    dims <- dimnames(ALPHA_draws)[[2]] 
    #splitting the output of the gibbs sampler for predictive density later on
    a0post <- ALPHA_draws[,which(dims=="constant"),]
    a1post <- ALPHA_draws[,which(dims=="trend"),] #coefficients on the trend
    a2post <- NULL
    alpha_var <- NULL
    dummiespost <- ALPHA_draws[,which(dims=="Dummies"),] #coefficients for the dummies
    postExpost <- ALPHA_draws[,which(dims=="Exogenous"),] #coefficients for the cont.exogenous
    postExlpost <- ALPHA_draws[,which(dims=="ExogenousLag"),] #coefficients for the lagged. ex
    Lambda0post <- ALPHA_draws[,which(dims=="Wex"),]#coefficients on WEX
    SIGMApost <- SIGMA_draws
    
    Lambdapost <- NULL
    Thetapost <- NULL
    
    for (jj in 1:p) {
      Lambdapost[[jj]] <- ALPHA_draws[,which(dims==paste("Wexlag",jj,sep="")),]
      Thetapost[[jj]]<- ALPHA_draws[,which(dims==paste("Ylag",jj,sep="")),]
    }
    
    
  }else if (prior==4){
    #augment actual data with dummys
    Y_ <- rbind(Y,ydum)
    X_ <- rbind(X,xdum)
    #Compute posterior moments
    V_post <- solve(crossprod(X_))
    A_post <- V_post%*%t(X_)%*%Y_
    S_post <- crossprod(Y-X%*%A_post)
    v_post <- T+v_prior
    
    rownames(A_post) <- colnames(X)
    colnames(A_post) <- colnames(A_OLS)
    SIGMA <- S_post/(T-K)
    dimnames(ALPHA_draws)=list(NULL,colnames(X),colnames(A_OLS))
    
    #  A_post <- apply(ALPHA_draws, c(2,3), mean)
    S_post <- apply(SIGMA_draws,c(2,3),mean)
    Res <- Y-X%*%A_post
    
    dims <- dimnames(ALPHA_draws)[[2]] 
    #splitting the output of the gibbs sampler for predictive density later on
    a0post <- ALPHA_draws[,which(dims=="constant"),]
    a1post <- ALPHA_draws[,which(dims=="trend"),] #coefficients on the trend
    a2post <- NULL
    alpha_var <- NULL
    dummiespost <- ALPHA_draws[,which(dims=="Dummies"),] #coefficients for the dummies
    postExpost <- ALPHA_draws[,which(dims=="Exogenous"),] #coefficients for the cont.exogenous
    postExlpost <- ALPHA_draws[,which(dims=="ExogenousLag"),] #coefficients for the lagged. ex
    Lambda0post <- ALPHA_draws[,which(dims=="Wex"),]#coefficients on WEX
    SIGMApost <- SIGMA_draws
    
    Lambdapost <- NULL
    Thetapost <- NULL
    
    for (jj in 1:p) {
      Lambdapost[[jj]] <- ALPHA_draws[,which(dims==paste("Wexlag",jj,sep="")),]
      Thetapost[[jj]]<- ALPHA_draws[,which(dims==paste("Ylag",jj,sep="")),]
    }
  }else if (prior==5){
    Xt <- X
    Yt <- Y
    T <- nrow(Xt); 
    #----------------------PRIOR FUN------------------------------
    #----------------------getting OLS estimates------------------ 
    XtXinv <- ginv(t(Xt)%*%Xt)
    A_OLS  <-  XtXinv%*%(t(Xt)%*%Yt)
    a_OLS <- as.vector(A_OLS) #vectorizes A_OLS, i.e. a_OLS=vec(A_OLS)
    SSE  <-  t((Yt - Xt%*%A_OLS))%*%(Yt - Xt%*%A_OLS)
    SIGMA_OLS  <-  SSE/(T-K+1)
    IXY  <-   kronecker(diag(M),(t(Xt)%*%Yt))
    #-------------Initialize Bayesian Posteriors using OLS values-
    alpha <- a_OLS # single draw from the posterior of alpha
    ALPHA <- A_OLS # -,,- ALPHA
    SSE_Gibbs <- SSE # of SSE
    SIGMA <- SIGMA_OLS #of SIGMA
    
    a_prior  <-  matrix(0,n,1)
    
    # This is the std of the OLS estimate ofalpha. You can use this to 
    # scale tau_0 and tau_1 (see below) if you want.
    # SSVS variances for alpha
    sigma_alpha  <-  sqrt(diag(kronecker(SIGMA_OLS,XtXinv)))
    
    tau_0  <-  0.1*sigma_alpha   # Set tau_[0i], tau_[1i]
    tau_1  <-  10*sigma_alpha
    
    ind_wex <- which(grepl("Wex",rep(colnames(X),M)))
    if (wexoff==1){
      tau_0[ind_wex] <- tau_1[ind_wex] <- 1/10^6
    }
    
    for (k in 1:ntot){
      # Draw psi|alpha,gamma,omega,DATA from the GAMMA dist.
      # Get S_[j] - upper-left [j x j] submatrices of SSE
      # The following loop creates a cell array with elements S_1,
      # S_2,...,S_j with respective dimensions 1x1, 2x2,...,jxj
      S <- list() #!!!!!!!
      for (kk_2 in 1:M){                                      
        S[[kk_2]]  <-  SSE_Gibbs[1:kk_2,1:kk_2]  
      }
      # Set also SSE =(s_[i,j]) & get vectors s_[j]=(s_[1,j] , ... , s_[j-1,j])
      s <- list()
      for (kk_3 in 2:M){
        s[[kk_3 - 1]]  <-  SSE_Gibbs[1:(kk_3 - 1),kk_3]
      }
      # Parameters for Eta|omega ~ N_[j-1](0,D_[j]*R_[j]*D_[j]), see eq. (15)
      # Create and update h_[j] matrix
      # If omega_[ij] = 0 => h_[ij] = kappa0, else...
      hh <- vector('list',M-1)
      
      for (kk_4 in 1:(M-1)){                 
        omeg  <-  omega[[kk_4]]
        het  <-  hh[[kk_4]]
        for (kkk in 1:dim(omeg)[1]){           
          if (omeg[kkk,1] == 0){
            het[kkk]  <-  kappa_0
          }else{                        
            het[kkk]  <-  kappa_1              
          }
        }
        hh[[kk_4]]  <-  het
      }            
      # D_j = diag(hh_[1j],...,hh_[j-1,j])
      D_j <- vector('list',M-1)
      for (kk_5 in 1:(M-1)) {          
        D_j[[kk_5]]  <-  diag(hh[[kk_5]])
      }
      D_j[[1]] <- hh[[kk_5]][1]
      # Now create covariance matrix D_[j]*R_[j]*D_[j], see eq. (15)
      DD_j <- vector('list',M-1)
      for (kk_6 in 1:(M-1)){
        DD  <-  D_j[[kk_6]]
        DD_j[[kk_6]] = (DD%*%DD);
      }
      # Create B_[i] matrix
      B <- vector('list',M)
      for (rr in 1:M) {          
        if (rr == 1){
          B[[rr]]  <-  b_i + 0.5*(SSE[rr,rr]);
        }else{if (rr > 1){
          s_i  <-  s[[rr-1]]
          S_i  <-  S[[rr-1]]
          DiDi  <-  DD_j[[rr-1]]
          B[[rr]]  <-  b_i + 0.5*(SSE_Gibbs[rr,rr] - t(s_i)%*%solve(S_i + solve(DiDi))%*%s_i)
        }
        }
      }
      #Now get B_i from cell array B, and generate (psi_[ii])^2
      B_i  <-  as.matrix(unlist(B));
      psi_ii_sq  <- matrix(0,M,1)
      for (kk_7 in 1:M){                
        psi_ii_sq[kk_7,1]  <-  rgamma(1,a_i + 0.5*T,B_i[kk_7,1]) #gamm_rnd(1,1,(a_i + 0.5*T),B_i(1,kk_7));
      }
      
      # Draw eta|psi,phi,gamma,omega,DATA from the [j-1]-variate
      # NORMAL dist.
      eta  <-  vector('list',M-1)
      for (kk_8 in 1:(M-1)){       
        s_i  <-  s[[kk_8]]
        S_i  <-  S[[kk_8]]
        DiDi  <-  DD_j[[kk_8]]
        miu_j  <-  - sqrt(psi_ii_sq[kk_8+1])*(solve(S_i + solve(DiDi))%*%s_i);
        Delta_j  <-  solve(S_i + solve(DiDi))
        
        eta[[kk_8]]  <-  miu_j + t(chol(Delta_j))%*%rnorm(kk_8,0,1);
      }
      
      # Draw omega|eta,psi,phi,gamma,omega,DATA from BERNOULLI dist.
      omega_vec  <-  NULL #temporary vector to store draws of omega
      for (kk_9 in 1:(M-1)){       
        omeg_g  <-  omega[[kk_9]]
        eta_g  <-  eta[[kk_9]]
        for (nn in 1:length(omeg_g)){  # u_[ij1], u_[ij2], see eqs. (32 - 33)                          
          u_ij1  <-  (1/kappa_0)*exp(-0.5*((eta_g[nn])^2)/((kappa_0)^2))*q_ij
          u_ij2  <-  (1/kappa_1)*exp(-0.5*((eta_g[nn])^2)/((kappa_1)^2))*(1-q_ij)
          ost  <-  u_ij1/(u_ij1 + u_ij2)
          omeg_g[nn,1]  <-  bernoulli(ost)
          omega_vec  <-  rbind(omega_vec , omeg_g[nn,1])
        }
        omega[[kk_9]]  <-  omeg_g
      }
      # Create PSI matrix from individual elements of "psi_ii_sq" and "eta"
      PSI_ALL  <-  matrix(0,M,M)
      for (nn_1 in 1:M){ # first diagonal elements
        PSI_ALL[nn_1,nn_1] <-  sqrt(psi_ii_sq[nn_1,1]);   
      }
      for (nn_2 in 1:(M-1)){ # Now non-diagonal elements
        eta_gg = eta[[nn_2]]
        for (nnn in 1:dim(eta_gg)[1]){
          PSI_ALL[nnn,nn_2+1]  <-  eta_gg[nnn]
        }
      }
      # Create SIGMA
      SIGMA  <- solve(PSI_ALL%*%t(PSI_ALL))                
      # Draw alpha              
      # Hyperparameters for alpha|gamma ~ N_[m](0,D*D)
      h_i = matrix(0,n,1)   # h_i is tau_0 if gamma=0 and tau_1 if gamma=1
      for (nn_3 in 1:n){
        if (gammas[nn_3,1] == 0){               
          h_i[nn_3,1]  <-  tau_0[nn_3]
        }else{if (gammas[nn_3,1] == 1){        
          h_i[nn_3,1]  <-  tau_1[nn_3]       
        }
        }
      }
      D  <-  diag(as.vector(t(h_i)%*%diag(n)))# Create D. Here D=diag(h_i) will also do
      DD  <-  D%*%D   # Prior covariance matrix for Phi_m
      isig <- solve(SIGMA)
      psi_xx  <-  kronecker(solve(SIGMA),(t(Xt)%*%Xt))
      V_post  <-  solve(psi_xx + diag(diag(1/DD)))
      
      visig <- as.vector(isig)
      a_post  <-  V_post%*%(IXY%*%visig + diag(diag(1/DD))%*%a_prior);
      alpha  <-  a_post + t(chol(V_post))%*%rnorm(n,0,1) # Draw alpha
      
      ALPHA  <-  matrix(alpha,K,M) # Draw of ALPHA
      
      # Draw gamma|phi,psi,eta,omega,DATA from BERNOULLI dist.    
      for (nn_6 in 1:n){
        u_i1  <-  (1/tau_0[nn_6])*exp(-0.5*(alpha[nn_6]/(tau_0[nn_6]))^2)*p_i        
        u_i2  <-  (1/tau_1[nn_6])*exp(-0.5*(alpha[nn_6]/(tau_1[nn_6]))^2)*(1-p_i)
        gst  <-  u_i1/(u_i1 + u_i2)
        if (gst=="NaN") gst <- 0 
        gammas[nn_6,1]  <-  bernoulli(gst) 
        gammas[is.na(gammas)] <- 1
      }
      # Save new Sum of Squared Errors (SSE) based on draw of ALPHA  
      SSE_Gibbs  <-  t(Yt - Xt%*%ALPHA)%*%(Yt - Xt%*%ALPHA)
      colnames(ALPHA) <- colnames(Y) 
      
      if (k>nburn){
        ALPHA_draws[k-nburn,,] <- ALPHA
        SIGMA_draws[k-nburn,,] <- SIGMA
        gamma_draws[k-nburn,] <- gammas
      }
      print(paste("Gibbs Sampling started:", round(k/ntot*100),"% finished"))
      print(paste("Burn-In-Phase:",if(k/nburn>=1){c("FINISHED!")}else{paste(round(k/nburn*100),"%")}))
    }
    dimnames(ALPHA_draws)=list(NULL,colnames(X),colnames(A_OLS))
    
    A_post <- apply(ALPHA_draws, c(2,3), mean)
    S_post <- apply(SIGMA_draws,c(2,3),mean)
    PIP <- matrix(apply(gamma_draws,2,mean),K,N)
    colnames(PIP) <- colnames(A_post);rownames(PIP) <- rownames(A_post)
    
    Res <- Y-X%*%A_post
    
    dims <- dimnames(ALPHA_draws)[[2]] 
    #splitting the output of the gibbs sampler for predictive density later on
    a0post <- ALPHA_draws[,which(dims=="constant"),]
    a1post <- ALPHA_draws[,which(dims=="trend"),] #coefficients on the trend
    a2post <- NULL
    alpha_var <- NULL
    dummiespost <- ALPHA_draws[,which(dims=="Dummies"),] #coefficients for the dummies
    postExpost <- ALPHA_draws[,which(dims=="Exogenous"),] #coefficients for the cont.exogenous
    postExlpost <- ALPHA_draws[,which(dims=="ExogenousLag"),] #coefficients for the lagged. ex
    Lambda0post <- ALPHA_draws[,which(dims=="Wex"),]#coefficients on WEX
    SIGMApost <- SIGMA_draws
    
    Lambdapost <- NULL
    Thetapost <- NULL
    
    for (jj in 1:p) {
      Lambdapost[[jj]] <- ALPHA_draws[,which(dims==paste("Wexlag",jj,sep="")),]
      Thetapost[[jj]]<- ALPHA_draws[,which(dims==paste("Ylag",jj,sep="")),]
    }
    
  }else if (prior==7){
    #augment actual data with dummys
    Y_ <- rbind(Y,ydum)
    X_ <- rbind(X,xdum)
    #Compute posterior moments
    V_post <- solve(crossprod(X_))
    A_post <- V_post%*%t(X_)%*%Y_
    S_post <- crossprod(Y-X%*%A_post)
    v_post <- T+v_prior
    
    rownames(A_post) <- colnames(X)
    colnames(A_post) <- colnames(A_OLS)
    
    S_post <- apply(SIGMA_draws,c(2,3),mean)
    Res <- Y-X%*%A_post
    
    dims <- dimnames(ALPHA_draws)[[2]] 
    #splitting the output of the gibbs sampler for predictive density later on
    a0post <- ALPHA_draws[,which(dims=="constant"),]
    a1post <- ALPHA_draws[,which(dims=="trend"),] #coefficients on the trend
    a2post <- NULL
    alpha_var <- NULL
    dummiespost <- ALPHA_draws[,which(dims=="Dummies"),] #coefficients for the dummies
    postExpost <- ALPHA_draws[,which(dims=="Exogenous"),] #coefficients for the cont.exogenous
    postExlpost <- ALPHA_draws[,which(dims=="ExogenousLag"),] #coefficients for the lagged. ex
    Lambda0post <- ALPHA_draws[,which(dims=="Wex"),]#coefficients on WEX
    SIGMApost <- SIGMA_draws
    
    Lambdapost <- NULL
    Thetapost <- NULL
    
    for (jj in 1:p) {
      Lambdapost[[jj]] <- ALPHA_draws[,which(dims==paste("Wexlag",jj,sep="")),]
      Thetapost[[jj]]<- ALPHA_draws[,which(dims==paste("Ylag",jj,sep="")),]
    }
    
  }
  #--------------Splits the posterior matrix & creates residuals---------------------
  dims <- dimnames(A_post)[[1]] 
  
  fit <- X%*%A_post
  
  #Res <- Y-X%*%A_post
  Lik <- 0
  #for (jj in 1:T){
  #  Lik <- Lik+dmvnorm(Y[jj,],(X%*%A_post)[jj,],SIGMA,log=TRUE)
  #}
  ML <- 0
  #ML <- -0.5*(-2*Lik+ncol(ALPHA)*nrow(ALPHA)*log(T))
  rownames(A_post) <- colnames(X);colnames(A_post) <- colnames(A_OLS)
  
  a0 <- A_post[which(dims=="constant"),] #coefficients on the constant
  a1 <- A_post[which(dims=="trend"),] #coefficients on the trend
  a2 <- NULL
  dummies <- A_post[which(dims=="Dummies"),] #coefficients for the dummies
  postEx <- A_post[which(dims=="Exogenous"),] #coefficients for the cont.exogenous
  postExl <- A_post[which(dims=="ExogenousLag"),] #coefficients for the lagged. ex
  Lambda0 <- A_post[which(dims=="Wex"),]#coefficients on WEX
  Lambda <- A_post[which(dims=="Wexlag"),] #coefficients on Wexlag
  Theta <- A_post[which(dims=="Ylag"),]#coefficients on endogenous lagged
  
  Lambda <- NULL
  Theta <- NULL
  
  for (jj in 1:p) {
    Lambda[[jj]] <- A_post[which(dims==paste("Wexlag",jj,sep="")),]
    Theta[[jj]]<- A_post[which(dims==paste("Ylag",jj,sep="")),]
  }
  
  
  #Data Splitting cbind(Dummies,Exogenous,Exlag,Wex,Wexlag,Ylag)
  DDummies <- Xfull[,which(dims=="Dummies")]
  DExogenous <- Xfull[,which(dims=="Exogenous")]
  DExogenousL <- Xfull[,which(dims=="ExogenousLag")]
  DWex <- Xfull[,which(dims=="Wex")]
  DWexlag <- Xfull[,which(dims=="Wexlag")]
  DEndlag <- Ylag[(p+1):nrow(Ylag),]
  
  
  return(list(Dummies=DDummies,End=Yfull,Exogenous=DExogenous,Exlag=DExogenousL,Wex=DWex,Wexlag=DWexlag,Ylag=DEndlag,A_post=A_post,
              Res=Res,a0=a0,a1=a1,a2=a2,dummies=dummies,postEx=postEx,postExl=postExl,Lambda0=Lambda0,Lambda=Lambda,Theta=Theta,p=p,bigX=X,X=X,W=W,a0post=a0post,a1post=a1post,a2post=a2post,
              dummiespost=dummiespost,postExpost=postExpost,postExlpost=postExlpost,Lambda0post=Lambda0post,Lambdapost=Lambdapost,Thetapost=Thetapost,SIGMApost=SIGMApost,alpha_Var=alpha_var,PL=PL,ALPHA_draws=ALPHA_draws,
              ML=ML,SIGMA=SIGMA,PIP=PIP,lambdas=lambdas,V_post=V_post))
}

#Stack the system and perform forecasting (uses snowfall parallel computing environment)
#---------------------------------------------------------------------------------------------------------------------#
comp_script <- function(fhorz,prior,wexoff=0,hyper= c(0.2,0.2,5^2,0.1)){
  enableJIT(2)
  #----------------------------------------------------------------------------------#
  #----------------------------this part does the stacking---------------------------#
  #parameters for VARX* estimation---------------------------------------------------#
  horizon <- 40
  fhorz <- 5
  levels <- 0
  exo <- 0
  par <- 1 
  diff <- 0 #if estimated in differences
  predDraw <- 150 # draws from the predictive density
  pdensity <- 1
  presmpl <- 0
  irhorizon <- 40
  dum <- 0
  Daten <- new.data#dataList
  IRhorz <- 0
  ssave <- 1 #how many rotation matrices do we have to save?
  vars <- c("y","Dp","rer","stir","ltir","eq","tc")
  #---------------------------------------------------------------------------------#
  x <- t(xglobal)
  names <- cN
#  hyper <- c(0.2^2,0.2^2,1000^2)
  fcsts_post <- array(0,dim=c(predDraw,nrow(x),12))
  BVAR <- cmpfun(BVAR)
  
  globalG <- list()
  predDens <- list()
  fcst_t <- array(0,c(predDraw,nrow(x),5,horizon))
  lambda_ot <- array(0,c(horizon,length(cN),4))
  
  for (ihorz in seq(1,horizon,1)){
    h <- horizon-ihorz+1 
    sfInit(parallel=TRUE,cpus=4)
    sfExport(list=list("wexoff","get_dum_ar","get_ML_minn","get_dum_minn","rmse","prior","h","horizon","get_dum","mlag","get_ML","bernoulli","BVAR","datahandling","xglobal","gW","horizon","Daten","cN","hyper"))
    predDens <- sfLapply(1:length(names),function(i) BVAR(hyper,i,prior,h,gW=gW,bigx=xglobal,Daten,cN,wexoff=wexoff))
    sfStop()
    #creates the global x matrix
    VAR0 <- predDens[[1]]
    x <- t(VAR0$End)
    for (i in 2:length(names)){
      VAR1 <- predDens[[i]]
      x <- rbind(x,t(VAR1$End))
    }
    for (i in 1:length(names)) globalG[[i]] <- predDens[[i]]$W
    
    VAR0 <- predDens[[1]]
    #stacking/solving like in pesaran
    #parameter stuff
    A0 <- cbind(diag(ncol(VAR0$End)),-t(VAR0$Lambda0))
    W0 <- globalG[[1]]
    
    #creates matrices according to PSW 2004 for every lag
    for (kk in 1:length(VAR0$Theta)){
      assign(paste("B0",kk,sep=""),cbind(t(VAR0$Theta[[kk]]),t(VAR0$Lambda[[kk]])))
      assign(paste("H0",kk,sep=""),get(paste("B0",kk,sep=""))%*%W0)
    }
    
    a0 <- matrix(VAR0$a0)
    # a1 <- matrix(VAR0$a1)
    G <- A0%*%W0
    #data stacking
    x <- t(VAR0$End)
    Ylag1 <- t(VAR0$Ylag)   
    lambda_ot[ihorz,1,] <- predDens[[1]]$lambda
    for (i in 2:length(names)){
      lambda_ot[ihorz,i,] <- predDens[[i]]$lambda
      
      #N might create a list containing all country specific W matrices and use that in here (should be much faster)
      VAR1 <- predDens[[i]]
      W1 <- globalG[[i]]
      A1 <- cbind(diag(ncol(VAR1$End)),-1*t(VAR1$Lambda0))
      
      for (kk in 1:length(VAR0$Theta)){
        assign(paste("B1",kk,sep=""),cbind(t(VAR1$Theta[[kk]]),t(VAR1$Lambda[[kk]])))
        assign(paste("H0",kk,sep=""),rbind(get(paste("H0",kk,sep="")),get(paste("B1",kk,sep=""))%*%W1))
      }
      
      #B1 <- cbind(t(VAR1$Thetapost[draw,,]),t(VAR1$Lambdapost[draw,,]))
      G <- rbind(G,A1%*%W1)
      #H <- rbind(H,B1%*%W1)
      a0 <- rbind(a0,matrix(VAR1$a0))
      # a1 <- rbind(a1,matrix(VAR1$a1))
      #Variables
      Ylag1 <- rbind(Ylag1,t(VAR1$Ylag))
      #resids <- rbind(resids,t(VAR1$End[1:(nrow(VAR1$End)-horizon),]-VAR1$X%*%VAR1$ALPHA_draws[draw,,]))
      x <- rbind(x,t(VAR1$End))
    }
    
    class(x) <- "numeric"
    
    b2 <- NULL
    b0 <- solve(G)%*%a0 #global constant

    for (kk in 1:length(VAR0$Theta)){
      assign(paste("F",kk,sep=""),solve(G)%*%get(paste("H0",kk,sep="")))
    }
    
    #err <- solve(G)%*%resids
    F_post <- list()
    for (kk in 1:length(VAR0$Theta)){
      F_post[[kk]] <- get(paste("F",kk,sep=""))
    }
    
    #this stuff is needed for producing the forecasts
    #----------------
    p <- length(VAR0$Theta)
    nn <- nrow(x)
    nd <- 1
    nl <- p
    
    varndxv <- c(nn,nd,nl)
    nkk <- (nl*nn)+nd
    
    Yn <- t(x)
    Xn <- mlag(Yn,p)
    Xn <- Xn[(p+1):nrow(Xn),]
    Yn <- Yn[(p+1):nrow(Yn),]
    Y0 <- t(Yn[(nrow(Yn)-h+1):nrow(Yn),,drop=FALSE])
    #colnames(Xn) <- rownames(x)
    M <- ncol(Yn)
    
    ALPHA <- NULL
    for (jj in 1:p){
      ALPHA <- cbind(ALPHA,F_post[[jj]])
    }
    ALPHA <- cbind(ALPHA,b0)
    
    bigx <- cbind(Xn,1)
    Xn <- bigx
    p_draw <- length(F)
    
    #Step I: Construct a global VC matrix Omega_t
    Sigma_t <- array(0,c(nrow(x),nrow(x),ncol(x)))
    Sigma <- list()
    
    for (k in 1:length(names)){
      Sigma[[k]] <-predDens[[k]]$SIGMA
    }
    Sig_t <- solve(G)%*%as.matrix(bdiag(Sigma))%*%t(solve(G))
    zt <- Xn[nrow(Yn)-h,]
    z1 <- zt
    Mean00 <- zt
    Sigma00 <- matrix(0,nkk,nkk)
    Cm <- diag(M)
    sig_array <- array(0,c(nrow(x),nrow(x),fhorz))
    for (ih in 1:fhorz){
      companion <- get_companion(ALPHA,varndxv)
      Jm <- companion$Jm;Mm <- companion$MM
      #first and second moments
      Mean00 <- Mm%*%Mean00
      Sigma00 <- Mm%*%Sigma00%*%t(Mm)+Jm%*%Sig_t%*%t(Jm)
      meanyt <- Cm%*%Mean00[1:nn]#+t(chol(Sig_t))
      varyt <- Cm%*%Sigma00[1:nn,1:nn]%*%t(Cm)
      sig_array[,,ih] <- t(chol(varyt))
    }
    for (ii in 1:predDraw){
      zt <- Xn[nrow(Yn)-h,]
      z1 <- zt
      Mean00 <- zt
      Sigma00 <- matrix(0,nkk,nkk)
      Cm <- diag(M)
      lpylv <- matrix(0,M,fhorz)
      lp_m <- matrix(0,fhorz,1)
      lp_var <- matrix(0,length(vars),fhorz)
      pitlv <- matrix(0,M,fhorz)
      y2 <- NULL
      for (ih in 1:fhorz){
        companion <- get_companion(ALPHA,varndxv)
        Jm <- companion$Jm;Mm <- companion$MM
        z1 <- Mm%*%z1
        yf <- z1[1:nn]+sig_array[,,ih]%*%rnorm(nn,0,1)
        y2 <- cbind(y2,yf)
      }
      if (any((ihorz:(ihorz+fhorz-1))>horizon)){
        slct <- seq(ihorz,horizon,fhorz)
      }else{
        slct <- ihorz:(ihorz+fhorz-1)
      }
      fcst_t[ii,,,slct] <- y2[,1:length(slct)]
     # print(ii)
    }
    #Scores_multiv[,1,ihorz:(ihorz+fhorz-1)] <- scores_fhorz
    print(h)
  }
  return(list(fcst=fcst_t))
}
#preliminary functions -------------------------------------
source("data_stuff_EW.R")
#source("Datahandling.R")
#source("minnesota_dummies.R")
#source("bvar_mean.R")
wish <- function(h,n){
  A = t(chol(h))%*%matrix(rnorm(size(h,1)*n,0,1),size(h,1),n)
  A = A%*%t(A);
}

mlag <- function(X,lag)
{
  p <- lag
  X <- as.matrix(X)
  Traw <- nrow(X)
  N <- ncol(X)
  Xlag <- matrix(0,Traw,p*N)
  for (ii in 1:p){
    Xlag[(p+1):Traw,(N*(ii-1)+1):(N*ii)]=X[(p+1-ii):(Traw-ii),(1:N)]
  }
  return(Xlag)  
}
bernoulli <- function(p){
  u <- runif(1)
  if (u<p){
    x=0
  }else{
    x=1
  } 
  return(x)
}
get_companion <- function(Beta_,varndxv){
  # Beta_ <- Atilda
  nn <- varndxv[[1]]
  nd <- varndxv[[2]]
  nl <- varndxv[[3]]
  
  nkk <- nn*nl+nd
  
  Jm <- matrix(0,nkk,nn)
  Jm[1:nn,1:nn] <- diag(nn)
  
  MM <- rbind(Beta_,cbind(diag((nl-1)*nn), matrix(0,(nl-1)*nn,nn+1)),c(matrix(0,1,nn*nl),1))
  
  return(list(MM=MM,Jm=Jm))
}

get_companion_lbvar <- function(Beta_,varndxv){
  nn <- varndxv[[1]]
  nd <- varndxv[[2]]
  nl <- varndxv[[3]]
  
  nkk <- nn*nl+nd
  Jm <- matrix(0,nkk,nn)
  Jm[1:nn,1:nn] <- diag(nn)
  MM <- rbind(t(Beta_), matrix(0,(nl-1)*nn,nn+1),c(matrix(0,1,nn*nl),1))
  
  return(list(MM=MM,Jm=Jm))
}

mlag <- function(X,lag)
{
  p <- lag
  X <- as.matrix(X)
  Traw <- nrow(X)
  N <- ncol(X)
  Xlag <- matrix(0,Traw,p*N)
  for (ii in 1:p){
    Xlag[(p+1):Traw,(N*(ii-1)+1):(N*ii)]=X[(p+1-ii):(Traw-ii),(1:N)]
  }
  return(Xlag)  
}

mlag <- function(X,lag)
{
  p <- lag
  X <- as.matrix(X)
  Traw <- nrow(X)
  N <- ncol(X)
  Xlag <- matrix(0,Traw,p*N)
  for (ii in 1:p){
    Xlag[(p+1):Traw,(N*(ii-1)+1):(N*ii)]=X[(p+1-ii):(Traw-ii),(1:N)]
  }
  return(Xlag)  
}

bernoulli <- function(p){
  u <- runif(1)
  if (u<p){
    x=0
  }else{
    x=1
  } 
  return(x)
}

datahandling <- function(Data,nr){
  #---------------------------------------------------------------------------------------------------------------#  
  #Input:Data and the number of the country in the dataset which is the current home country
  #Output: Data_Country , a list, where Data_Country[[2]] refers to the true exogenous variables, Data_Country[[3]] 
  #are the weak exogenous variables and Data_Country[[4]] are the endogenous variables and Country[[1]] are the mn
  #This function feeds in DATA and creates a 1 x K vector which indicates which variables are exogenous, own lags 
  #lags of other variables
  #indicator 0 means home country, 1 denotes the rest of the world and 2 are truly exogenous variables
  #WARNING: original data needs labels for the countries in order to create the indicator vector
  #---------------------------------------------------------------------------------------------------------------# 
  Daten <- as.data.frame(Data) #reads in  data and converts it to a data.frame
  names  <-  colnames(Daten)
  cols <- ncol(Daten)
  indicator  <-  matrix("NA",1,ncol(Daten))
  ind  <- substr(names,1,2)
  
  number  <-nr #indicates which country is selected
  
  IND <- ind[!duplicated(ind)]
  
  for (i in 1:cols){
    
    if (grepl(IND[number],names[i]))  {
      
      indicator[i]=0 
      
    }else indicator[i]=1
    if(grepl(IND[length(IND)],names[i])) indicator[i]=2
    
  }
  
  sortingM <- rbind(indicator,as.matrix(Daten))
  
  #optional: would put the choosen country's columns at the start of the matrix, using indicator would be more efficient i guess
  sort1.data <- sortingM[,order(sortingM[1,],decreasing="TRUE")]
  
  #splitting the data into (true) exogenous, weak exogenous and system variables
  #could be more elegant, but it works
  ex <- as.matrix(which(sort1.data[1,]==2, arr.ind=T))
  wex <- as.matrix(which(sort1.data[1,]==1, arr.ind=T))
  end <- as.matrix(which(sort1.data[1,]==0, arr.ind=T))
  #Exogenous variables need extra treatment to extract dummys
  Exogenous <- sort1.data[2:nrow(sort1.data),ex]
  Exnames <- colnames(Exogenous)
  inddummy <- substr(Exnames,7,10)
  dummies <- matrix("NA",1,ncol(Exogenous))
  
  for (j in 1:ncol(Exogenous)){
    
    if (grepl("Dumm",Exnames[j])) dummies[j]=1 else dummies[j]=0
  }
  class(dummies) <- "numeric"
  
  Exogenous <- rbind(dummies,Exogenous)
  sort.Ex <- Exogenous[,order(Exogenous[1,],decreasing="TRUE")]
  
  tex <- as.matrix(which(sort.Ex[1,]==0),arr.ind=T)
  dum <- as.matrix(which(sort.Ex[1,]==1),arr.ind=T)
  
  Dummies <- sort.Ex[2:nrow(sort.Ex),dum]
  Exogenous <- sort.Ex[2:nrow(sort.Ex),tex]
  
  
  WExogenous <- sort1.data[2:nrow(sort1.data),wex]
  Endogenous <- sort1.data[2:nrow(sort1.data),end]
  
  assign(paste("WEx_",IND[number],sep=""),WExogenous) #creates a matrix WEx_Countryname
  assign(paste("END_",IND[number],sep=""),Endogenous) # same, we dont need this for Exogenous because it stays the same for all countries
  assign(paste("DataFULL_",IND[number],sep=""),rbind(indicator,as.matrix(Daten))) #returns the full matrix with a indicator row
  
  assign(paste("",IND[number],sep=""),list(IND,Dummies,Exogenous,assign(paste("WEx_",IND[number],sep=""),WExogenous),assign(paste("END_",IND[number],sep=""),Endogenous)))
  
  return(get(IND[nr]))
}

getweights <- function(nr,mixed,real,fin,Data){
  data1 <- datahandling(Data,nr)
  cnames <- data1[[1]]
  xglobal <- Data[[1]]
  class(xglobal) <- "numeric"
  colnames(xglobal) <- paste(cnames[1],colnames(xglobal),sep=".")
  xglobal <- xglobal[,colSums(is.na(xglobal))<nrow(xglobal)]
  
  for (jj in 2:length(Data)){
    temp <- Data[[jj]];class(temp) <- "numeric"
    temp <- temp[,colSums(is.na(temp))<nrow(temp)]
    colnames(temp) <- paste(cnames[jj],colnames(temp),sep=".")
    xglobal <- cbind(xglobal,temp)
  }
  
  #xglobal <- xglobal[,!substr(colnames(xglobal),4,10)=="epepsus"];xglobal <- xglobal[,!substr(colnames(xglobal),4,10)=="p"];#xglobal <- xglobal[,!substr(colnames(xglobal),4,10)=="eq"] #deletes variables not needed
  colnames(xglobal) <- substr(colnames(xglobal),1,7); xglobal <- xglobal[,!duplicated(colnames(xglobal))];#xglobal <- xglobal[,-which(colnames(xglobal)=="EG.stir")]
  varnames <- substr(colnames(xglobal),4,7); varnames <- varnames[!duplicated(varnames)] #creates a dynamic list of variables
  varnames <- varnames[!varnames=="rer"]
  endnames <- substr(colnames(xglobal[,substr(colnames(xglobal),1,2)==cnames[[nr]]]),4,7);endnames <- endnames[!duplicated(endnames)]
  
  W <- matrix(0,length(varnames),ncol(xglobal));colnames(W) <- colnames(xglobal);rownames(W) <- varnames
  WeightsREAL <- real ; WeightsFIN <- fin 
  
  if (mixed==1){
    financials <- c("ltir.a","stir.a","eq","tc")
    wghtsreal1 <- WeightsREAL[nr,]; wghtsfin1 <- WeightsFIN[nr,]
    
    for (k in 1:(nrow(W)-1)){
      if (rownames(W)[[k]] %in% financials){
        W[k,substr(colnames(W),4,7)==rownames(W)[k]] <- wghtsfin1[substr(names(W[k,substr(colnames(W),4,7)==rownames(W)[k]] ),1,2)]
      }else{
        W[k,substr(colnames(W),4,7)==rownames(W)[k]] <- wghtsreal1[substr(names(W[k,substr(colnames(W),4,7)==rownames(W)[k]] ),1,2)]
      }
    }
    if (cnames[[nr]]=="US") W["poil", "US.poil"] <- wghtsreal1["US"] else W["poil", "US.poil"] <- wghtsreal1["US"]/wghtsreal1["US"]
    
  }else{
    wghtsreal1 <- WeightsREAL[nr,]
    for (k in 1:(nrow(W)-1)){
      W[k,substr(colnames(W),4,7)==rownames(W)[k]] <- wghtsreal1[substr(names(W[k,substr(colnames(W),4,7)==rownames(W)[k]] ),1,2)]
    }
  }
  #if (cnames[[nr]]=="US") W["com", "US.com"] <- wghtsreal1["US"] else W["com", "US.com"] <- wghtsreal1["US"]/wghtsreal1["US"]
  if (cnames[[nr]]=="US") W["poil", "US.poil"] <- wghtsreal1["US"] else W["poil", "US.poil"] <- wghtsreal1["US"]/wghtsreal1["US"]
  #cross check for "NaN"
  W[which(W=="NaN")] <- 1
  #----------------------here we specify the part for the endogenous variabes-----------------------------------------#
  endoW <- matrix(0,length(endnames),ncol(W))
  endonr <- xglobal[,substr(colnames(xglobal),1,2)==cnames[nr]];rownames(endoW) <- colnames(endonr)
  colnames(endoW) <- colnames(W)
  namesW <- colnames(endoW)
  namesNr <- colnames(endonr)
  
  for (j in 1:nrow(endoW)){
    for (i in 1:length(namesW)){
      
      if (grepl(namesNr[[j]],namesW[[i]])) endoW[j,i]=1
      
    }
  }
  WfinNR <- rbind(endoW,W)
  
  WfinNR <- WfinNR[!(rowSums(abs(WfinNR)) == 0),]
  return(list(W=WfinNR,bigx=xglobal))
}
#-----------------------RMSE function-----------------------------------#
rmse <- function(x,y) sqrt(mean((x-y)^2))

#---------------------------------------- Prepares the data and creates weighting matrices----------------------------#
gW <- list();Wstorage <- list()

names <- names(new.data)

xglobal <- getweights(1,0,Data=new.data,fin=W.list$finW0709,real=W.list[[1]])
W1 <- xglobal$W
xglobal <- xglobal$bigx
#xglobal <- xglobal[64:nrow(xglobal),] #ONLY for long datasets

for (k in 1:length(names)){
  temp <- getweights(k,0,Data=new.data,fin=W.list$finW0709,real=W.list[[1]])
  tempW <- apply(temp$W,2,function(x) x/(rowSums(temp$W)))
  gW[[k]] <- tempW
}
bigx <- xglobal

#--------------------------------------- Estimates some models--------------------------------------------------------#
#source("W1.R") #Sources the data preparation file 
gvar_dens_diff <- comp_script(fhorz,1,wexoff=0)
gvar_dens_MIN <- comp_script(fhorz,2,wexoff=0)
gvar_dens_GLP <- comp_script(fhorz,3,wexoff=0)
gvar_dens_MIN_conjugate <- comp_script(fhorz,4,wexoff=0)
bvar_dens <- comp_script(fhorz,3,wexoff=1)
ssvs_dens <- comp_script(fhorz,5,wexoff=0)
ssvs_dens_var <- comp_script(fhorz,5,wexoff=1)
