
remove_outliers <- function(x, na.rm = TRUE, ...) {
  qnt <- quantile(x, probs=c(.25, .75), na.rm = na.rm, ...)
  H <- 1.5 * IQR(x, na.rm = na.rm)
  y <- x
  y[x < (qnt[1] - H)] <- NA
  y[x > (qnt[2] + H)] <- NA
  y
}

load_data <- getwd()
files <- "/Data/dataList_36c79Q22014-08-05.rda"
#pp_ <- "/Daten/pp.txt"
load(paste(load_data,files,sep=""))
#pp <- read.delim(paste(load_data,pp_,sep=""))
Dummy <- dataList$exo
W.list <- list()
W.list[[1]] <- apply(dataList$tradeArray[,,1:(33-10)],c(1,2),mean)
W.list[[1]] <- apply(W.list[[1]],2,function(x) x/(rowSums(W.list[[1]])))
#pp <- read.delim("~/Dropbox/UNI/PhD/GVAR Density/Daten/pp.txt")
#com <- pp[(nrow(pp)-139+1):nrow(pp),7]

new.data <- dataList
new.data$exo <- NULL;new.data$tradeArray <- NULL;new.data$finArray <- NULL
#Add poil to US
temp <- new.data$US
names_US <- c(colnames(temp),"poil")
temp <- cbind(temp,Dummy[,1])
colnames(temp) <- names_US
new.data$US <- temp

cN <- names(new.data)
#cN <- cN[-which(cN=="IN")]
#cN <- cN[-which(cN=="SA")]
#only for pesaran dataset
#cN <- intersect(colnames(W.list[[1]]),names(new.data))
#new.data <- new.data[cN]
outliers <- new.data

for (k in 1:length(cN)){
  if (cN[[k]]=="US"){
    sl_vars <- c("y","Dp","stir.a","ltir.a","eq","poil","tc")
  }else{
    sl_vars <- c("y","Dp","rer","stir.a","ltir.a","eq","tc")
  }
  temp <- as.matrix(new.data[[k]])
  
  #NA checking
  check_na <- matrix(sapply(new.data[[k]],is.na),nrow(temp),ncol(temp))
  check_na <- colSums(check_na)
  nakill <- which(check_na>5)
  if (length(nakill)>0){
    temp <- temp[,-nakill]
  }
  temp[is.na(temp)] <- 0
  temp1 <- temp
  #temp <- temp[,-(which(colSums(temp)==0))]
  for (jj in 1:ncol(temp)){
      #ind <- is.between(temp[,jj],quantile(temp[,jj],0.0135),quantile(temp[,jj],0.9875))
      test <- boxplot(temp[,jj])
      ind <- temp[,jj] %in% test$out
      temp[,jj] <- remove_outliers(temp[,jj])
      temp1[,jj] <- temp[,jj]
      temp[,jj] <- spline(temp[,jj],n=length(temp[,jj]))$y#na.approx(temp[,jj])#mean(temp[,jj],na.rm=TRUE)
  }
  tmp_vars <- colnames(temp)
  slct <- intersect(sl_vars,tmp_vars)
  outliers[[k]] <- temp1[,slct]
  new.data[[k]] <- temp[,slct]
}
outlier_overview <- NULL

for (jj in 1:length(cN)){
  temp <- t(outliers[[jj]])
  rownames(temp) <- paste(cN[[jj]],rownames(temp))
  
  outlier_overview <- rbind(outlier_overview,temp)
}


